/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.image.entity;

@javax.persistence.NamedQueries(
 {



   
 }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "BILD")
// @javax.persistence.IdClass(BildPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class Bild
extends AbstractBild
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public Bild() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Bild(Bild original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "bild_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "Bild")
    @javax.persistence.TableGenerator(name = "Bild", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "Bild", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient BildPK pkCache;

  @Override
  public BildPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new BildPK(getId());
    }

    return pkCache;
  }

  public static <E extends Bild> java.util.Map<BildPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<BildPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends Bild> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;


  public void resetAttributeChanged() {
        hasChangedContentBase64 = false;
          hasChangedMimeType = false;
  


        
    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Basic(fetch=javax.persistence.FetchType.LAZY)
  @javax.persistence.Lob
  @javax.persistence.Column(name = "CONTENT_BASE64", nullable = BildConstants.CONTENT_BASE64_NULLABLE, length = Integer.MAX_VALUE)
    
  protected java.lang.String contentBase64 =  null;

  @javax.persistence.Transient
  protected boolean hasChangedContentBase64 = false;

  public boolean hasChangedContentBase64(){
    return hasChangedContentBase64;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertContentBase64 = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenContentBase64;
  
  /**
   * 
   *
   * getter for BILD.CONTENT_BASE64
   *
   * (LAZY LOADING)
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getContentBase64() {
        return contentBase64;
      }

  /**
   * 
   *
   * setter for BILD.CONTENT_BASE64
   *
   * @param contentBase64
   */
  @Override   public void setContentBase64(@javax.annotation.Nullable  java.lang.String contentBase64) {

       resetTkCache();
                  java.lang.String contentBase64Internal = org.apache.commons.lang3.StringUtils.trimToNull(contentBase64);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.contentBase64
      , contentBase64Internal);

      attributeChanged |= thisAttributChanged;

      hasChangedContentBase64 |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("contentBase64");
      }


             if (!isSeitLadenVeraendertContentBase64) {
          isSeitLadenVeraendertContentBase64 = thisAttributChanged;
         if (isSeitLadenVeraendertContentBase64){
           wertNachLadenContentBase64=this.contentBase64;
         }
       }
      

       this.contentBase64 = contentBase64Internal;

         }

        
  @javax.persistence.Column(name = "MIME_TYPE", nullable = BildConstants.MIME_TYPE_NULLABLE, length=BildConstants.MIME_TYPE_MAX_LENGTH)
        
  protected java.lang.String mimeType =  null;

  @javax.persistence.Transient
  protected boolean hasChangedMimeType = false;

  public boolean hasChangedMimeType(){
    return hasChangedMimeType;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertMimeType = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenMimeType;
  
  /**
   * 
   *
   * getter for BILD.MIME_TYPE
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getMimeType() {
        return mimeType;
      }

  /**
   * 
   *
   * setter for BILD.MIME_TYPE
   *
   * @param mimeType
   */
  @Override   public void setMimeType(@javax.annotation.Nullable  java.lang.String mimeType) {

       resetTkCache();
                  
                          java.lang.String mimeTypeInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(mimeType, BildConstants.MIME_TYPE_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.mimeType
      , mimeTypeInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedMimeType |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("mimeType");
      }


             if (!isSeitLadenVeraendertMimeType) {
          isSeitLadenVeraendertMimeType = thisAttributChanged;
         if (isSeitLadenVeraendertMimeType){
           wertNachLadenMimeType=this.mimeType;
         }
       }
      

       this.mimeType = mimeTypeInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */

/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Bild:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Bild other){
                             other.contentBase64 = this.contentBase64;
                                other.mimeType = this.mimeType;
           
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Bild.class)){
        copyEntityAttributesUsingSetter((Bild) other.castTo(Bild.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Bild: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Bild other){
               other.setContentBase64(this.contentBase64);
                  other.setMimeType(this.mimeType);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Bild other){
                       if (hasChangedContentBase64) {
        other.setContentBase64(this.contentBase64);
      }
                             if (hasChangedMimeType) {
        other.setMimeType(this.mimeType);
      }
             }





    @javax.persistence.Transient
    private transient BildTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public BildTK getBildTK(){
    if (tkCache==null) {
    tkCache = new BildTK(



  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getBildTK();
    }

  @Override
  public BildUK getUk(){
    return getBildUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Bild.class;
  }

public BildUK getBildUK(){

   return  new BildUK(



  );
}

  @javax.persistence.Transient
  private transient BildProperties properties;

  public BildProperties getProperties(){
    if (properties == null) {
      properties = new BildProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public BildProperties getBildProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return BildConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(BildConstants.MESSAGE_KEY_CONTENT_BASE64_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(BildConstants.MESSAGE_KEY_CONTENT_BASE64_EINZAHL);

        contentBase64 =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(BildConstants.MESSAGE_KEY_MIME_TYPE_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(BildConstants.MESSAGE_KEY_MIME_TYPE_EINZAHL);

        mimeType =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertContentBase64) {
      result.put(BildConstants.MESSAGE_KEY_CONTENT_BASE64_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.LOB
                , wertNachLadenContentBase64 , contentBase64));
    }
                            if (isSeitLadenVeraendertMimeType) {
      result.put(BildConstants.MESSAGE_KEY_MIME_TYPE_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenMimeType , mimeType));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertContentBase64 = false;
      wertNachLadenContentBase64 = null;
                          isSeitLadenVeraendertMimeType = false;
      wertNachLadenMimeType = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "BILD";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "Bild";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

  @javax.persistence.Transient
  private transient boolean hashCodeBerechnet = false;

  @javax.persistence.Transient
  private transient int hashCode = 0;


  @Deprecated // nur in Unit-Tests verwenden(!)
  public void resetHashCode() {
    hashCodeBerechnet = false;
    hashCode = 0;
  }

  @Override
    public int hashCode() {
      if (hashCodeBerechnet) {
      return hashCode;
    }

    if (id == null) {
      hashCode = super.hashCode();
    } else {
      hashCode = id.hashCode();
    }

    hashCodeBerechnet = true;

    return hashCode;

    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(BildConstants.CONTENT_BASE64_MAX_LENGTH ,  contentBase64, this, BildConstants.MESSAGE_KEY_CONTENT_BASE64_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(BildConstants.MIME_TYPE_MAX_LENGTH ,  mimeType, this, BildConstants.MESSAGE_KEY_MIME_TYPE_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        @Override
        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }
                              }
